#include <cmath>
#include <iostream>
#include <FL/gl.H>
#include <FL/glut.H>

using namespace std;

#include "ball.h"
#include "vector_3d.h"
#include "point_3d.h"


Ball::Ball ()
    : Object (Point_3d (0,0,0),
              Vector_3d (0,0,0)),
              radius (20.0)
{
}

Ball::Ball (const Point_3d &pt, const double &r)
    : Object (pt, Vector_3d (0, 0, 0)), radius (r)
{
}

Ball::Ball (const Ball &that)
{
    *this = that;
}

Ball &Ball::operator= (const Ball &that)
{
    if (this == &that)
        return *this;
    this->position = that.position;
    this->velocity = that.velocity;
    this->collided = that.collided;
    this->radius = that.radius;
    return *this;
}

bool Ball::collide (const Object &other)
{
    return false;
}

void Ball::resolve_collision (Object &other)
{

}

void Ball::update()
{
    //"friction"
    //terminal velocity

    //cout << velocity.magnitude() << endl;
    if (velocity.magnitude () < 0.5 && collided)
    {
        cout << "velocity below threshhold" << endl;
        velocity = Vector_3d (0, 0, 0);
    }
    else if (velocity.magnitude() > 45)
    {
        velocity = velocity.unit_vector() * 45.0;
    }
    else 
    {
        if (!collided)
            velocity = velocity - Vector_3d ( 0.0, 0.2, 0);
        velocity = velocity * 0.9888;
    }
    //cout << velocity << endl;
    position = position + velocity;
}

void Ball::draw()
{
    glTranslatef( (float) position.get_x(), (float) position.get_y(), (float) position.get_z());
    glColor3f(1.0, 1.0, 1.0);
    glutSolidSphere (radius, 30, 30);
}

/*
Point_3d Ball::get_pos() const
{
    return position;
}
*/