#ifndef __FLIPPER_H__
#define __FLIPPER_H__

#define _USE_MATH_DEFINES
#include <math.h>

#include "polygon.h"

class Flipper
    : public Poly
{
private:
    double angledelta;
    double angle;
    double orientation;
    void translate_points();
    Line rotate_points (const Line &);
public:
    Flipper ();
    Flipper (const Flipper &that);
    Flipper &operator= (const Flipper &that);
    Flipper (const Point_3d &, 
             const std::vector<Line> &,
             const bool & = true,
             const Vector_3d & = Vector_3d (0,0,0));
    virtual bool collide (Object &other);
    virtual void resolve_collision (Object &other);
    virtual void update();
    virtual void draw();

    double get_angle () const;
    void set_angle (const double &);
};

#endif