#ifndef __LINE_H__
#define __LINE_H__

#include "point_3d.h"
#include "objects.h"

class Line
    : public Object
{
private:
    Point_3d pta;
    Point_3d ptb;
    Point_3d get_closest_point (Point_3d P, bool segmentClamp);

public:
    Line ();
    Line (const Line &that);
    Line &operator= (const Line &that);

    Line (const Point_3d &, const Point_3d &);
    virtual bool collide (Object &other);
    virtual void resolve_collision (Object &other);
    virtual void update();
    virtual void draw ();
    Point_3d get_a () const;
    Point_3d get_b () const;
    void set_a (const Point_3d &);
    void set_b (const Point_3d &);
};

#endif