#ifndef __OBJECTS_H__
#define __OBJECTS_H__

#include <iostream>
#include <vector>

#include "point_3d.h"
#include "vector_3d.h"

class Object
{
protected:
    Point_3d position;
    Vector_3d velocity;
    bool collided;
public:
    Object ()
        : position (Point_3d (0,0,0)), 
          velocity (Vector_3d (0,0,0)),
          collided (false)
    {}

    Object (const Point_3d &pos, const Vector_3d &vel)
        : position (pos), velocity (vel), collided (false) { }
    Object (const Object &that)
    {
        *this = that;
    }
    Object &operator= (const Object &that)
    {
        if (this == &that)
            return *this;
        this->position = that.position;
        this->velocity = that.velocity;
        this->collided = that.collided;
        return *this;
    }
    virtual bool collide (const Object &other)
    {
        std::cout << "Object method called" << std::endl;
        return false;
    }
    virtual void resolve_collision (Object &other) { }
    virtual void update ()
    {
        position = position + velocity;
    }
    virtual void draw () { }

    bool get_col () const {  return collided;  }
    Point_3d get_pos () const {  return position;  }
    Vector_3d get_vel () const {  return velocity;  }
    void set_pos (const Point_3d &pt) {  position = pt;  }
    void set_vel (const Vector_3d &vel) {  velocity = vel;  }
    void set_col (const bool &col) { collided = col; }
};

#endif