#ifndef __POINT_3D_H__
#define __POINT_3D_H__

#include "vector_3d.h"

class Point_3d
{
private:
    double xcoord;
    double ycoord;
    double zcoord;
public:
    //ctors, copy, asg, etc
    Point_3d ();
    Point_3d (const double &x, const double &y, const double &z);
    Point_3d (const Point_3d &that);
    Point_3d &operator= (const Point_3d &that);

    //stuff
    Vector_3d distance (const Point_3d &) const;

    //gets (check out my doubles)
    double get_x() const;
    double get_y() const;
    double get_z() const;

    //sets
    void set_x (const double &);
    void set_y (const double &);
    void set_z (const double &);

    //operator overloading
    friend Point_3d operator+ (const Point_3d &, const Vector_3d &);
    friend Vector_3d operator- (const Point_3d &, const Point_3d &);
    friend Point_3d operator- (const Point_3d &, const Vector_3d &);
    friend bool operator== (const Point_3d &, const Point_3d &);
    friend bool operator!= (const Point_3d &, const Point_3d &);
    friend std::ostream &operator<< (std::ostream &out, const Point_3d &that);
};

#endif