#include <iostream>
#include <vector>
#include <FL/gl.H>

using namespace std;

#include "objects.h"
#include "polygon.h"

Poly::Poly ()
    : Object (), 
      edges (vector<Line> ())
{
    /*
    edges.push_back (Line (Point_3d (-10, 10, 0), Point_3d (-10, -10, 0)));
    edges.push_back (Line (Point_3d (-10,-10, 0), Point_3d ( 10,-10, 0)));
    edges.push_back (Line (Point_3d ( 10,-10, 0), Point_3d ( 10, 10, 0)));
    edges.push_back (Line (Point_3d ( 10, 10, 0), Point_3d (-10, 10, 0)));
    */
}

Poly::Poly (const Point_3d &pos, 
            const std::vector<Line> &vert, 
            const Vector_3d &vec)
    : Object (pos, vec), edges (vert)
{
}

Poly::Poly (const Poly &that)
{
    *this = that;
}

Poly &Poly::operator= (const Poly &that)
{
    if (this == &that)
        return *this;
    this->position = that.position;
    this->velocity = that.velocity;
    this->collided = that.collided;
    this->edges = that.edges;
    return *this;
}


bool Poly::collide (Object &other)
{
    bool retval = false;
    vector<Line>::iterator start = edges.begin();
    vector<Line>::iterator end = edges.end();
    for (; start != end; ++start)
    {
        retval = retval || start->collide (other);
    }
    other.set_col (retval);
    return retval;
}

void Poly::resolve_collision (Object &other)
{

}

void Poly::update ()
{

}

void Poly::draw ()
{
    vector<Line>::iterator start = edges.begin();
    vector<Line>::iterator end = edges.end();
    for (; start != end; ++start)
    {
        glPushMatrix();
        start->draw();
        glPopMatrix();
    }
}