#ifndef __POLYGON_H__
#define __POLYGON_H__

#include "objects.h"
#include "line.h"

class Poly
    : public Object
{
protected:
    std::vector<Line> edges;
public:
    Poly ();
    Poly (const Poly &that);
    Poly &operator= (const Poly &that);
    Poly (const Point_3d &, 
          const std::vector<Line> &,
          const Vector_3d & = Vector_3d (0,0,0));
    virtual bool collide (Object &other);
    virtual void resolve_collision (Object &other);
    virtual void update();
    virtual void draw();
};

#endif