#ifndef __VECTOR_3D_H__
#define __VECTOR_3D_H__

class Vector_3d
{
private:
    double xcomp;
    double ycomp;
    double zcomp;
public:
    //ctors, copy, asg, etc
    Vector_3d ();
    Vector_3d (const double &x, const double &y, const double &z);
    Vector_3d (const Vector_3d &that);
    Vector_3d &operator= (const Vector_3d &that);

    //get sets
    double get_x () const;
    double get_y () const;
    double get_z () const;
    void set_x (const double &x);
    void set_y (const double &y);
    void set_z (const double &z);

    //LA stuff
    double magnitude () const;
    double dot_product (const Vector_3d &) const;
    Vector_3d unit_vector () const;

    //operator overloading
    friend Vector_3d operator+ (const Vector_3d &, const Vector_3d &);
    friend Vector_3d operator- (const Vector_3d &, const Vector_3d &);
    friend Vector_3d operator* (const Vector_3d &, const double &);
    friend Vector_3d operator* (const double &, const Vector_3d &);
    friend Vector_3d operator- (const Vector_3d &);
    friend std::ostream &operator<< (std::ostream &out, const Vector_3d &that);
};

#endif